<?php

//Theme Setup
ob_start();
define('TEMPLATE_PATH', get_template_directory()); //Template directory path
define('TEMPLATEURL', get_template_directory_uri());
define('ADMINPATH', get_template_directory() . '/admin/');
define('ADMINURL', get_template_directory_uri() . '/admin/');
define('LIBRARYPATH', TEMPLATE_PATH . '/library/');
define('LIBRARYURL', get_template_directory_uri() . '/library/');

function business_directory_add_style(){
	if (!is_admin()) {   
            wp_enqueue_style('stylesheet',get_stylesheet_uri(),'','','all');
        }
}
add_action('wp_enqueue_scripts','business_directory_add_style');

function business_directory_get_option($name) {
    $options = get_option('business_directory_options');
    if (isset($options[$name]))
        return $options[$name];
}

function business_directory_update_option($name, $value) {
    $options = get_option('business_directory_options');
    $options[$name] = $value;
    return update_option('business_directory_options', $options);
}

function business_directory_delete_option($name) {
    $options = get_option('business_directory_options');
    unset($options[$name]);
    return update_option('business_directory_options', $options);
}

/**
 * Includes files from parent theme or child theme
 * @param type $files file name, array or string
 * @param type $path directory name, resides the file you are including
 */
function business_directory_do_include($files, $path = null) {
    $ext = '.php';
    if ($path !== null) {
        $parent = get_template_directory() . '/' . $path . '/';
        $child = get_stylesheet_directory() . '/' . $path . '/';
    } else {
        $parent = get_template_directory() . '/';
        $child = get_stylesheet_directory() . '/';
    }
    if (is_array($files) && !empty($files)) {
        foreach ($files as $file) {
            if (file_exists($child . $file . $ext)) {
                include_once ($child . $file . $ext);
            } elseif (file_exists($parent . $file . $ext)) {
                include_once ($parent . $file . $ext);
            } else {
                echo $file . $ext . NT_FND;
            }
        }
    } else {
        if (file_exists($child . $files . $ext)) {
            include_once ($child . $files . $ext);
        } elseif (file_exists($parent . $files . $ext)) {
            include_once ($parent . $files . $ext);
        } else {
            echo $files . $ext . NT_FND;
        }
    }
}

/**
 * These files build out the options interface.  
 * Likely won't need to edit these. 
 */
business_directory_do_include('admin_main', 'admin'); // manage theme filters in the file

/**
 * Include core library file 
 */
business_directory_do_include('lib_main', 'library'); // manage theme filters in the file
ob_clean();



